;нупюммне сярпниярбн б оюпе я янрнбшл рекетнмнл
;опх пюгпшбе кхмхх ябъгх я гюдепфйни гюлшйюеряъ
;ймнойю бшгнбю дпсцнцн рекетнмю.
;пюгпюанрвхй м. гюеж
;SAES@MAIL.RU
;югнб, пнярнбяйни.
;опнцпюллю OXX
;юяяелакеп MPLAB IDE v8.56

;============================
	LIST	P=PIC12F509
	#INCLUDE <P12F509.INC>
            __CONFIG 0X01A
;============================
;хяонкэгсеряъ бмсрпеммхи цемепюрнп вюярнрни 4 лцж.
;================================================
	CBLOCK	H'07'
MSK		;бпелъ оюсгш.
FLAG	;пецхярп ткюцнб.
	ENDC
;=====================================
	MOVWF	OSCCAL	
	MOVLW	B'00000001'	;0 - бунд.
	TRIS	GPIO
	MOVLW	B'10000111'	;K=256, TMR0.
	OPTION
	CLRF	MSK
	CLRF	GPIO
	CLRF	FLAG
	CALL	ZAD		;30 яей гюдепфйю.
	CALL	ZAD
	CALL	ZAD
	CALL	ZAD		;
	CALL	ZAD
	CALL	ZAD
	BSF		GPIO,5	;бйкчвхл гекемши яберндхнд.
	BCF		GPIO,4	;
	BTFSS	GPIO,0	;фдел напшбю ькеитю.
	GOTO	$-1
KHOP
	BSF		GPIO,2	;бйкчвхл охрюмхе.
	CALL	ZAD		;ймнойю мюфюрю.
	CALL	ZAD
	CALL	ZAD
	BCF		GPIO,2	;бшйкчвхл охрюмхе.
	CALL	ZAD		;ймнойю нросыемю.
	CALL	ZAD
	BSF		GPIO,1	;бйкчвхл ймнойс.
	CALL	ZAD		;ймнойю мюфюрю.
	CALL	ZAD
	CALL	ZAD
	BCF		GPIO,1	;бшйкчвхл ймнойс.
	CALL	ZAD		;ймнойю нросыемю.
	CALL	ZAD
	CALL	ZAD
	BSF		GPIO,2	;бшйкчвхл охрюмхе.
	CALL	ZAD		;ймнойю мюфюрю.
	CALL	ZAD
	CALL	ZAD
	BCF		GPIO,2	;бшйкчвхл охрюмхе.
	CALL	ZAD		;ймнойю нросыемю.
	BTFSC	FLAG,0	;еякх оепбши бшгнб ядекюм,
	GOTO	$+5		;рн гюбепьюел.
	BSF		FLAG,0	;оепбши бшгнб ядекюм.
	CALL	ZAD
	CALL	ZAD
	GOTO	KHOP	;мю брнпни бшгнб.
	BSF		GPIO,4	;ялемхл жбер яберндхндю.
	BCF		GPIO,5	;бйкчвем йпюямши.
	GOTO	$		;нярюмнб.
ZAD	
	CLRF	TMR0	;гюдепфйю 5,22 яей.
	MOVLW	0XFF
	SUBWF	TMR0,0
	BTFSS	STATUS,Z
	GOTO	$-3
	CLRF	TMR0
	INCF	MSK,1
	MOVLW	.80
	SUBWF	MSK,0
	BTFSS	STATUS,Z
	GOTO	$-8
	CLRF	MSK
	RETLW	0
;===============================
            END
;===============================